
DebugMessageList = []
# Make a 2 dimensional list, 1st dimension give the entry for the debug code received
# 2nd dimension gives the [Debug code label, number of payload bytes to expect after the code is received]
DebugMessageList.append(["UnUsed",                           0])     
DebugMessageList.append(["Initialize_Variables",             0])     # 1
DebugMessageList.append(["Version_Load",                     0])     # 2
DebugMessageList.append(["Begin_BT_Setup",                   1])     # 3 - 1 byte, Bluetooth Status Flags
DebugMessageList.append(["Power_up_by_Battery_Check",        0])     # 4
DebugMessageList.append(["Factory_Startup_Mode",             0])     # 5
DebugMessageList.append(["Load_ExEE_data",                   0])     # 6
DebugMessageList.append(["Enter_Test_Mode",                  0])     # 7
DebugMessageList.append(["Check_for_Errors_at_Power_Up",     0])     # 8
DebugMessageList.append(["Reset_Registers_in_Ext_EEPROM",    0])     # 9
DebugMessageList.append(["Store_Water_Usage",                0])     # 10
DebugMessageList.append(["Store_Peak_Flow",                  0])     # 11
DebugMessageList.append(["Store_Gallons_Between_Regen",      0])     # 12
DebugMessageList.append(["Change_BT_baud_rate_to_38400",     0])     # 13
DebugMessageList.append(["Going_to_Sleep",                   0])     # 14
DebugMessageList.append(["Wake_from_Sleep",                  0])     # 15
DebugMessageList.append(["Power_LT_2_4V",                    0])     # 16
DebugMessageList.append(["Power_LT_4_5V",                    0])     # 17
DebugMessageList.append(["Check_the_Battery_Voltage",        0])     # 18
DebugMessageList.append(["Encoder_Count_Changed",            1])     # 19 - 1 byte, Current Encoder position
DebugMessageList.append(["Running_on_Battery_Recognized",    0])     # 20
DebugMessageList.append(["Send_BT_Homepage_Data",            0])     # 21
DebugMessageList.append(["Send_BT_Dashboard_Data",           0])     # 22
DebugMessageList.append(["Send_BT_Settings_Data",            0])     # 23
DebugMessageList.append(["Send_BT_History_Data",             0])     # 24
DebugMessageList.append(["Send_BT_Dealer_Data",              0])     # 25
DebugMessageList.append(["Update_BT_Password",               0])     # 26
DebugMessageList.append(["Batt_mode_in_Regen_set_Bypass",    0])     # 27
DebugMessageList.append(["Motor_Current_GT_390mA",           0])     # 28
DebugMessageList.append(["Clear_Bypass_Mode",                0])     # 29
DebugMessageList.append(["Reset_Data_After_Regen",           0])     # 30
DebugMessageList.append(["Regen_Trig_by_Time_of_Day",        0])     # 31
DebugMessageList.append(["Start_Recovery_Regeneration",      0])     # 32
DebugMessageList.append(["Start_Regeneration",               0])     # 33
DebugMessageList.append(["Encoder_Change_Handler",           0])     # 34
DebugMessageList.append(["Rising_Encoder_Edge_Seen",         0])     # 35
DebugMessageList.append(["Falling_Encoder_Edge_Seen",        0])     # 36
DebugMessageList.append(["Power_Sw_Clears_Avg_Slot_Len",     0])     # 37
DebugMessageList.append(["Average_Slot_Length_Reset",        0])     # 38
DebugMessageList.append(["Large_Home_Slot_Found",            0])     # 39
DebugMessageList.append(["Error_2_or_Error_4_Triggered",     0])     # 40
DebugMessageList.append(["Start_Motor_Forward",              0])     # 41
DebugMessageList.append(["Start_Motor_Reverse",              0])     # 42
DebugMessageList.append(["Motor_Stop",                       0])     # 43
DebugMessageList.append(["Encoder_Slot_Time_Changed",        0])     # 44
DebugMessageList.append(["Encoder_Slot_Time_Reset",          0])     # 45
DebugMessageList.append(["Reset_Encoder_Timers",             0])     # 46
DebugMessageList.append(["Present_Flow_Rate",                0])     # 47
DebugMessageList.append(["Restore_Current_Encoder_Pos",      1])     # 48 - 1 byte, Restored encoder value
DebugMessageList.append(["Encoder_Input_Reading_HILO",       1])     # 49 - 1 byte, Encoder Input current state: High/Low
DebugMessageList.append(["Encoder_Direction_Change1",        1])     # 50 - 1 byte, Current Encoder position
DebugMessageList.append(["Start_of_Main_Loop",               0])     # 51
DebugMessageList.append(["Encoder_Direction_Change2",        1])     # 52 - 1 byte, Current Encoder position
DebugMessageList.append(["Store_Meter_Cal_Data",             1])     # 53 - 1 byte, 0 = Called by Load External EE Data, 12 = D12 settings stored, 15 = D15 settings stored
DebugMessageList.append(["Send_BT_Firmware_DL_to_App",       1])     # 54 - 1 byte, Firmware Batch Number
DebugMessageList.append(["Write_Int_EEPROM",                 0])     # 55
DebugMessageList.append(["Water_Meter_Pulse_Edge",           0])     # 56
DebugMessageList.append(["Update_BT_Name",                   0])     # 57
DebugMessageList.append(["WDT_Reset_Occurred",               1])     # 58 - 1 byte, watchdog flag: Timer 0, 1, 2, 4 clear their respective bits
DebugMessageList.append(["Enter_Main_Loop",                  0])     # 59
DebugMessageList.append(["Load_IntEE_data",                  0])     # 60
DebugMessageList.append(["BT_Radio_Off",                     0])     # 61
DebugMessageList.append(["BT_Radio_On",                      0])     # 62
DebugMessageList.append(["BT_Rx_Buff_Overflow",              0])     # 63
DebugMessageList.append(["BT_Rx_Frame_Error",                0])     # 64
DebugMessageList.append(["BT_Processing_Rx_Data",            1])     # 65 - 1 byte, First byte of BT data received: r = Reset command, s = Test Mode, t = Home Page, u = Dashboard data, v = Advanced page data, w = History page data, x = Dealer info data, y = Factory Setup data
DebugMessageList.append(["BT_Processing_Firmware_UL",        0])     # 66
DebugMessageList.append(["BT_Rx_Overrun_Error",              0])     # 67
DebugMessageList.append(["Prefill_soak_timer_dec",           1])     # 68 - 1 byte, Soak Timer value
DebugMessageList.append(["Start_Prefill",                    0])     # 69
DebugMessageList.append(["Cant_Start_Regen_Bat_Mode",        0])     # 70
DebugMessageList.append(["BT_Char_Buff_Reset",               0])     # 71
DebugMessageList.append(["Invalid_Command_Rx",               0])     # 72
DebugMessageList.append(["Homepage_PW_Rx",                   0])     # 73
DebugMessageList.append(["Homepage_FWDL_Rx",                 0])     # 74
DebugMessageList.append(["Homepage_FWUL_Rx",                 1])     # 75 - 1 byte, Firmware Batch Number
DebugMessageList.append(["BT_Processing_Rx_Done",            0])     # 76
DebugMessageList.append(["Incomplete_FWUL_packet",           0])     # 77
DebugMessageList.append(["Send_BT_TestMode_Data",            0])     # 78
DebugMessageList.append(["Test_Mode_Step",                   3])     # 79 - 3 bytes, Test Mode Step, Test mode pass flags (2 bytes).
DebugMessageList.append(["Int_EEPROM_Success",               0])     # 80
DebugMessageList.append(["Int_EEPROM_Restore",               0])     # 81
DebugMessageList.append(["Send_BT_FactorySetup_Data",        0])     # 82
DebugMessageList.append(["Goto_Shutoff",                     0])     # 83
DebugMessageList.append(["Leave_Shutoff",                    0])     # 84

LABEL = 0
PAYLOAD_SIZE = 1

DebugExtrasList = []                     # These are for temporary debugging
DebugExtrasList.append([ "UnUsed", 0])
DebugExtrasList.append(["Extra_1", 0])                         # 101
DebugExtrasList.append(["Extra_2", 0])                         # 102
DebugExtrasList.append(["Extra_3", 0])                         # 103
DebugExtrasList.append(["Extra_4", 0])                         # 104
DebugExtrasList.append(["Extra_5", 0])                         # 105

from saleae.analyzers import HighLevelAnalyzer, AnalyzerFrame, StringSetting

class SigDebug(HighLevelAnalyzer):

    def __init__(self):
        self.byte_count = 0
        self.debug_code_info = []
        self.debug_label = "UnKnown"
        self.debug_payload = 0
        self.DC_start_time = None
        self.payload_data = []
      
    def decode(self, frame: AnalyzerFrame):        # The `data` field only contains one byte

        if self.byte_count == 0:
            self.debug_label = "UnKnown"
            self.payload_data = []
            
        input_byte  = frame.data['data'] [0]
        self.byte_count += 1

        if self.byte_count == 1:
            debug_code = input_byte
            self.DC_start_time = frame.start_time           # Record the start time of the debug code
            DC_end_time = frame.end_time                    # Record the end time of the debug code

            if debug_code < len(DebugMessageList):
                self.debug_code_info = DebugMessageList[debug_code]

            elif debug_code > 100 and debug_code < (100 + len(DebugExtrasList)):
                self.debug_code_info = DebugExtrasList[debug_code - 100]

            self.debug_label = self.debug_code_info[LABEL]
            self.debug_payload = self.debug_code_info[PAYLOAD_SIZE]

        if self.byte_count > 1:
            self.payload_data.append(input_byte)
            DC_end_time = frame.end_time            # Extend the end of the debug code frame

        if self.debug_payload <= (self.byte_count - 1):
        
            self.byte_count = 0
            if self.debug_payload == 0:
                return AnalyzerFrame(self.debug_label, self.DC_start_time, DC_end_time, {})
            
            else:
                if self.debug_label == "Encoder_Count_Changed" \
                or self.debug_label == "Encoder_Direction_Change1" \
                or self.debug_label == "Encoder_Direction_Change2" \
                or self.debug_label == "Restore_Current_Encoder_Pos":
                    return AnalyzerFrame(self.debug_label, self.DC_start_time, DC_end_time, {
                         'Cnt': self.payload_data[0]
                     })
                elif self.debug_label == "Encoder_Input_Reading_HILO":
                    if self.payload_data [0] == 0:
                        return AnalyzerFrame(self.debug_label, self.DC_start_time, DC_end_time, {
                             'Low'
                         })
                    else:
                        return AnalyzerFrame(self.debug_label, self.DC_start_time, DC_end_time, {
                             'High'
                         })
                elif self.debug_label == "Send_BT_Firmware_DL_to_App" \
                  or self.debug_label == "Homepage_FWUL_Rx":
                    return AnalyzerFrame(self.debug_label, self.DC_start_time, DC_end_time, {
                         'Batch': self.payload_data[0]
                     })
                elif self.debug_label == "Test_Mode_Step":
                    return AnalyzerFrame(self.debug_label, self.DC_start_time, DC_end_time, {
                         'Step': self.payload_data[0]
                     })
                else:
                    return AnalyzerFrame(self.debug_label, self.DC_start_time, DC_end_time, {
                         'Data': self.payload_data[0]
                     })
        
